Index: tractimevisualizerplugin/impl.py
===================================================================
--- tractimevisualizerplugin/impl.py	(revision 2860)
+++ tractimevisualizerplugin/impl.py	(working copy)
@@ -92,18 +92,19 @@
 
     # outer join may return zero or '' if there is no such field, so we use arithmetic opration -0.0 to 'cast' result to be valid float value
     sql = """
-        SELECT t.id, t.time, t.status, t.milestone, est.value-0.0, th.value-0.0, t.component
+        SELECT t.id, t.time, t.status, t.milestone, est.value, th.value, t.component
         FROM ticket t
             LEFT OUTER JOIN ticket_custom est ON (t.id = est.ticket AND est.name = 'estimatedhours')
             LEFT OUTER JOIN ticket_custom th ON (t.id = th.ticket AND th.name = 'totalhours')
         ORDER BY t.id
         """
-    for (ticket,time, status,milestone,estimate,totalhours,component) in cursor.execute(sql).fetchall():
+    cursor.execute(sql)
+    for (ticket,time, status,milestone,estimate,totalhours,component) in cursor.fetchall():
         tickets[ticket] = {'ticket':ticket,
                            'status':status,
                            'milestone':milestone,
-                           'estimate':estimate,
-                           'totalhours':totalhours,
+                           'estimate':tofloat(estimate),
+                           'totalhours':tofloat(totalhours),
                            'time':time,
                            'component':component}
         #print>>debug, "ticket #%d: %s" % (ticket, str(tickets[ticket]))
@@ -135,7 +136,8 @@
             FROM ticket_change
             WHERE time=%d AND ticket=%d AND field IN('estimatedhours', 'totalhours', 'milestone', 'component') 
             ORDER BY time desc""" % (t,id)
-        data = cursor.execute(sql).fetchall()
+        cursor.execute(sql)
+        data = cursor.fetchall()
         # print>>debug, "ticket_change data:"
         #for line in data:
         #    print>>debug, line
@@ -154,10 +156,12 @@
     # -- find out timestamps (revisions) and bind processors for them
 
     timestamps = {}
-    for line in cursor.execute("SELECT DISTINCT time, id from ticket ORDER BY time").fetchall():
+    cursor.execute("SELECT DISTINCT time, id from ticket ORDER BY time")
+    for line in cursor.fetchall():
         timestamps[int(line[0])] = [(process_ticket_create, int(line[1]))]
 
-    for line in cursor.execute("SELECT DISTINCT time, ticket from ticket_change ORDER BY time").fetchall():
+    cursor.execute("SELECT DISTINCT time, ticket from ticket_change ORDER BY time")
+    for line in cursor.fetchall():
         item = timestamps.get(int(line[0]),[])
         item.insert(0, (process_ticket_change, int(line[1])))
         timestamps[int(line[0])] = item
@@ -238,8 +242,8 @@
     # todo: margin as percents
     #margin = 2
 
-    fx = 100.0 / largesttime
-    fy = 100.0 / maxhours
+    fx = 100.0 / max(largesttime, 1)
+    fy = 100.0 / max(maxhours, 1)
 
     svg =\
 """<?xml version="1.0" standalone="no"?>
@@ -288,13 +292,13 @@
     "This is just for testing the stuff from command line"
 
     def build_svg_paramlist(db, **args):
-        return build_svg(args)
+        return build_svg(db, args)
 
     from trac.env import open_environment
-    env = open_environment("c:\\scm\\trac\\visualizerdemo")
+    import sys
+    env = open_environment(sys.argv[1]) # use first argument as trac enviroment path
     db = env.get_db_cnx()
-    import sys
-    svg = build_svg_paramlist(db, milestone='mile1', time_interval=3600*24, debug=sys.stdout, datestart="8/1/07", dateend="10/1/07")
+    svg = build_svg_paramlist(db, milestone='milestone1', time_interval=3600*24, debug=sys.stdout, datestart="8/1/07", dateend="10/1/07")
 
     FILE = open("c:\\test.svg", "w")
     FILE.write(svg)
